<template>
  <div>
    <div id="nav">
      <Header />
    </div>
    <div class="container-fluid" v-if="$store.state.isUserLoggedIn">
      <h1>Le profil de</h1>

      <h4>{{ username }}</h4>

      <button @click="deleteAccount(userId)">Supprimer mon compte</button>
    </div>

     <div class="notconnectedMsg" v-else>
        <p>Vous devez être connecté pour avoir accès à cette page</p>
        <router-link class="user-link" to="/"
          >S'inscrire / Se connecter</router-link
        >
      </div>
      
  </div>
</template>

<script>
import AuthenticationService from "@/services/AuthenticationService";
import Header from "@/components/Header";
import axios from "axios";

export default {
  name: "profile",
  components: {
    Header,
  },

  data() {
    return {
      userId: "",
      username: "",
    };
  },

  async mounted() {
    // do a request once the page is loaded to the backend
    try {
      const token = localStorage.getItem("token");
      const username = localStorage.getItem("username");
      this.username = username;
      const userId = localStorage.getItem("userId");
      this.userId = userId;
      if (token !== null) {
        this.$store.dispatch("setToken", token);
        axios.defaults.headers.common["Authorization"] = token;
      }
    } catch (error) {
      if (error.response.status == 403) {
        localStorage.removeItem("token")
        this.$store.dispatch("setToken", null);
      } else {
      this.error = error.response.data.error;
    }
    }
  },

  methods: {
    deleteAccount: async function () {
      try {
        await AuthenticationService.deleteAccount(this.userId);
        localStorage.removeItem("token");
        this.$router.push("/");
      } catch (error) {
        this.error = error.response.data.error;
      }
    },
  },
};
</script>

<style scoped>
h1 {
  color: #d1515a;
  margin-bottom: 20px;
}
button {
  margin-top: 10px;
  border-radius: 10px;
  padding: 10px 50px;
  font-size: 0.9rem;
  background-color: #091f43;
  color: white;
}
</style>

